
(function(){

	// Will be used as lock to don't fire the initialization of the client until all scritps are loaded
	var fb_load_counter = 0;
	
	var data_name_fb = document.getElementById( "form_init_script" ).getAttribute( "data-name" );
	
	// jQuery file for the form
	var jQueryFile = data_name_fb + "common/libs_js/jquery-1.4.4.min.js";
	
	// Variable which will contain the jQuery version the FB will use
	var $fb;
	
	// JS files the form needs
	var js_files = [
		data_name_fb + "common/libs_js/jquery-ui-1.8.9.custom.min.js",
		data_name_fb + "common/libs_js/jquery.ui.datepicker.js",
		data_name_fb + "common/js/jquery.validate.js",
		data_name_fb + "common/libs_js/jquery.metadata.js",
		data_name_fb + "common/libs_js/jquery.placeholder.min.js",
		data_name_fb + "validation_data.js"+ '?' + Math.floor( Math.random()*1001 ),
		data_name_fb + "common/js/validation.js"
	];
	
	if( navigator.appName == 'Microsoft Internet Explorer' ) {
		// adds the JSON script if we are on IE browser
		js_files.splice( 0, 0, data_name_fb + "common/libs_js/json2.js" )
	}
	
	// CSS files needed to style the form
	var css_files = [
		data_name_fb + "common/css/jquery-ui-1.8.5.custom.css",
		data_name_fb + "common/css/normalize.css"
	];

	// Once the jQuery is loaded we launch our scripts to be loaded in parallel
	var fb_start_load = function ()
	{
		// Set the jquery form variable
	    $.noConflict();
	    $fb = jQuery;

	    // Add the required JS files for the form
		for( var i = 0; i < js_files.length; i++ )	{
			requireJS( js_files[i], fb_load_script );
		}
	}

	// Function will be called with each js resource file
	var fb_load_script = function() {

		// We use the counter as lock to be sure all files needed are loaded
	    if( fb_load_counter < js_files.length - 1 )
	    {
	        fb_load_counter++;
	        return;
	    }
		else
		{
			fb_init_form()
		}
	}
	
	function fb_init_form()
	{
		// Checks if we are in the preview
		var isPreview = document.getElementById( "docContainer" ).getAttribute( "data-form" ) == 'preview';

		// Initializes the validation of the form
		var pValidateClient = new ValidateClient( $fb );
		pValidateClient.init_client( isPreview );

		// Adds the location in case it is being embedded without iframe and it is not being shown on the sdrive page
		if( $fb('input[name="fb_form_custom_html"]').length && $fb("#docContainer").attr('data-form') == 'automated' && $fb("#docContainer").attr('action') != "./" )
		{
			$fb('input[name="fb_form_custom_html"]').get(0).value = parent.location.href;
		}
		
		// Adds the location in case it is being embedded with iframe
		if( $fb('input[name="fb_form_embedded"]').length && parent.frames.length != 0 && $fb("#docContainer").attr('data-form') == 'publish' )
		{
			$fb('input[name="fb_form_embedded"]').get(0).value = "1";
		}
		
		// If we are working on sdrive (iframe or auto embedded), add the stats code see (empire:#1740)
		if( parent.frames.length != 0 || $fb("#docContainer").attr('action').indexOf('http') != -1 || $fb("#docContainer").attr('action') == "./" ){
			$fb('#docContainer input[type!="submit"],#docContainer select,#docContainer textarea').change( function( event ) {
				$fb('#docContainer input[type!="submit"],#docContainer select,#docContainer textarea').unbind( event );
				var action = $fb('#docContainer').attr( 'action' );
				action = action.replace( /(?:\.php)|\/$/i , '/fbapp/api/formchangestats.php' );
				$fb.get( action );
			});
		}
		
		// Adds the function for hiding the hints for checkboxes and radiobuttons
		$fb("#docContainer .fb-checkbox, #docContainer .fb-radio, #docContainer .fb-dropdown, #docContainer .fb-listbox").parent().mouseleave( function() {
			var hint_element = $fb(".showing_hint", this);
			if( hint_element != undefined )
				hint_element.removeClass("showing_hint").addClass("hidden_hint");
		} );

		$fb("#docContainer input:file").parent().parent().mouseleave( function() {
			var hint_element = $fb(".showing_hint", this);
			if( hint_element != undefined )
				hint_element.removeClass("showing_hint").addClass("hidden_hint");
		} );

		$fb("#docContainer input:checkbox, #docContainer input:radio").blur( function() {
			var hint_element = $fb(".showing_hint", $fb(this).parent().parent().parent() );
			if( hint_element != undefined )
				hint_element.removeClass("showing_hint").addClass("hidden_hint");
		} );

		$fb("#docContainer .column select, #docContainer .column input, #docContainer .column textarea").blur( function() {
			var hint_element = $fb(".showing_hint", $fb(this).parent().parent() ) ;
			if( hint_element != undefined )
				hint_element.removeClass("showing_hint").addClass("hidden_hint");
		});

		// Adds the function for showing the hints for checkboxes and radiobuttons
		$fb("#docContainer .fb-checkbox, #docContainer .fb-radio, #docContainer .fb-dropdown, #docContainer .fb-listbox").parent().mouseenter( function() {
			var hint_element = $fb(".hidden_hint", this);
			if( hint_element != undefined )
				hint_element.removeClass("hidden_hint").addClass("showing_hint");
		} );

		$fb("#docContainer input:file").parent().parent().mouseenter( function() {
			var hint_element = $fb(".hidden_hint", this);
			if( hint_element != undefined )
				hint_element.removeClass("hidden_hint").addClass("showing_hint");
		} );

		$fb("#docContainer input:checkbox, #docContainer input:radio").focus( function() {
			var hint_element = $fb(".hidden_hint", $fb(this).parent().parent().parent());
			if( hint_element != undefined )
				hint_element.removeClass("hidden_hint").addClass("showing_hint");
		} );

		$fb("#docContainer .column select, #docContainer .column input, #docContainer .column textarea").focus( function() {
			var hint_element = $fb(".hidden_hint", $fb(this).parent().parent() );
			if( hint_element != undefined) {
				hint_element.removeClass("hidden_hint").addClass("showing_hint");
		}
		});
			
			
		// Triggers the validation change on the files inputs
		$fb("input:file").change(function() {
	       	$fb("#docContainer").validate().element(this);
		} );
		
		// Triggers the validation change on the urls inputs
		$fb("input[type=url]").blur(function() {
	       	$fb("#docContainer").validate().element(this);
		} );
		
		// Triggers the validation change on the urls inputs
		$fb("input[type=email]").blur(function() {
	       	$fb("#docContainer").validate().element(this);
		} );
		
		// Triggers the validation change on the urls inputs
		$fb("input[type=password]").blur(function() {
	       	$fb("#docContainer").validate().element(this);
		} );

		// Triggers the validation change on the files numbers
		$fb("input[type=number]").keyup(function() {
				// Value of the default validation
				var pluginValidation = $fb('#docContainer').validate().element(this);

				// Checks if there is elements invalid on the browser so we show our custom error (only for non IE based)
				if( navigator.appName != 'Microsoft Internet Explorer' &&
				 		$fb( '#' + this.id + ':invalid').length > 0 && 
						( pluginValidation == undefined || pluginValidation == true ) ) {
					var name = this.name;
					var error = {};
					error[name] = 'Input must be a valid number'
					$fb('#docContainer').validate().showErrors( error );
				} else {
					// In case we have a default validation error we show that one
					$fb('label[for="' + this.id + '"]').remove();
					$fb('#docContainer').validate().element(this);
				}
			}).blur(function() {
				// After losing focus we reset the default validation
				$fb('label[for="' + this.id + '"]').remove();
				$fb('#docContainer').validate().element(this)
		});
		
		// Fallback to support the placeholders HTML5
		var isInputSupported = 'placeholder' in document.createElement('input');
	  	var isTextareaSupported = 'placeholder' in document.createElement('textarea');
		if( !isInputSupported )
		{
			$fb('#docContainer input').placeholder();
		}

		if( !isTextareaSupported )
		{
			$fb('#docContainer textarea').placeholder();
		}
		
		// Applies the plugins loaded
		var vJSPlugins = [];
		var vCSSPlugins = [];
		
		// Saves the lists of plugins in the config object
		if( data_jsplugins != undefined && data_jsplugins.length > 0 ) 		vJSPlugins = JSON.parse( data_jsplugins );
		if( data_cssplugins != undefined && data_cssplugins.length > 0 ) 	vCSSPlugins = JSON.parse( data_cssplugins );
		
		for( var i = 0; i < vJSPlugins.length; i++ )
		{
			requireJS( vJSPlugins[i] );
		}
		
		for( var i = 0; i < vCSSPlugins.length; i++ )
		{
			requireCSS( vCSSPlugins[i] );
		}
	 }

	// Function to load the resources javascripts
	var requireJS = function(jspath,callback) {
	  var fileref=document.createElement('script')
	  fileref.setAttribute("type","text/javascript")
	  fileref.setAttribute("src", jspath )
	  if( callback != undefined ) {
		if( fileref.addEventListener ) {
			fileref.addEventListener("load",callback,false);
		} else if( fileref.attachEvent ) {
			fileref.attachEvent(  "onreadystatechange",
				function() {
					if( fileref.readyState == "complete" || fileref.readyState == "loaded" )
						callback();
				}
			);
		}
	  }
	  
	  document.getElementsByTagName("head")[0].appendChild(fileref);
	}

	// Function to load the CSS files
	var requireCSS = function(csspath) {
	  var fileref=document.createElement("link")
	  fileref.setAttribute("rel", "stylesheet")
	  fileref.setAttribute("type", "text/css")
	  fileref.setAttribute("href", csspath )
	  document.getElementsByTagName("head")[0].appendChild(fileref);
	}

	// Request the css needed for the form
	for( var i = 0; i < css_files.length; i++ )	{
		requireCSS( css_files[i] );
	}
		
	// Request the load of jQuery
	requireJS( jQueryFile, fb_start_load );

})();
